/*
 * Copyright 2009 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.lisp.subr;

import net.morilib.lisp.LispDouble;
import net.morilib.lisp.LispExactReal;
import net.morilib.lisp.LispInteger;
import net.morilib.lisp.LispNumber;

public class Div extends MathOperator2 {

	@Override
	protected LispNumber calculate(LispNumber o1, LispNumber o2) {
		return o1.div(o2);
	}

	@Override
	protected LispNumber calculateUnary(LispNumber o1) {
		if(o1 instanceof LispExactReal) {
			return LispInteger.ONE.div(o1);
		} else if(o1 instanceof LispDouble) {
			return (new LispDouble(1.0)).div(o1);
		}
		throw new IllegalArgumentException(o1.toString());
	}

}
